/*
 * Kangaroo Punch MultiPlayer Game Server Mark II
 * Copyright (C) 2020-2021  Scott Duensing
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */


#include "memory.h"
#include "util.h"


FILE *_memoryLog = NULL;


#ifdef MEMORY_CHECK_ENABLED
void mwLogW(FILE *p);
#endif


FILE *memoryLogHandleGet(void) {
	return _memoryLog;
}


#ifdef MEMORY_CHECK_ENABLED
void memoryOutput(int c) {
	fputc(c, _memoryLog);
	fflush(_memoryLog);

#ifdef __linux__
	// Also output to stdout on Linux.
	fputc(c, stdout);
	fflush(stdout);
#endif
}
#endif


void memoryShutdown(void) {
#ifdef MEMORY_CHECK_ENABLED
	unlink("memwatch.log");  // It just insists on creating this!
	mwTerm();
#endif
}


void memoryStartup(char *appName) {
	char *logName = utilAppNameWithNewExtensionGet(appName, "log");

	_memoryLog = fopen(logName, "w");

#ifdef MEMORY_CHECK_ENABLED
	mwLogW(_memoryLog);
	mwSetOutFunc(memoryOutput);
	mwInit();
#endif

	free(logName);
}
